# print_string_arm2.s

# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_WRITE,    4

# Other definitions
.equ STDOUT,	       1

        .globl _start
_start:
	ldr	r1,=hello
	bl	print_string		@ Print Hello World
	ldr	r1,=mystery
	bl	print_string		@
	ldr	r1,=goodbye
	bl	print_string		@ Print Goodbye
	

        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
        mov     r7,#SYSCALL_EXIT	@ put exit syscall number (1) in eax
	swi	0x0			@ and exit


	#====================
	# print string
	#====================
	# Null-terminated string to print pointed to by r1
	# r1 is trashed by this routine
	
print_string:

	push	{r0,r2,r7,r10,lr}	@ Save r0,r2,r3,lr on stack
	
	mov	r2,r1			@ copy string pointer
	
count_loop:
	ldrb	r10,[r2],#1		@ load byte from address r1+r2
	cmp	r10,#0			@ Compare against 0
	bne	count_loop		@ if not 0, loop

	sub	r2,r2,r1		@ subtract to get size
	
	mov	r0,#STDOUT		@ Print to stdout
	mov	r7,#SYSCALL_WRITE	@ Load syscall number
	swi	0x0			@ System call

	pop	{r0,r2,r7,r10,pc}	@ pop r0,r2,r3,pc from stack	
	
	
.data
hello:		.string "Hello World!\n"   @ includes null at end
mystery:	.byte 63,0x3f,63,10,0      @ mystery string
goodbye:	.string "Goodbye!\n"	   @ includes null at end
